
package server;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import server.messaging.AckMessage;
import server.messaging.CreateQueueRequestMessage;
import server.messaging.DeleteQueueRequestMessage;
import server.messaging.GetRequestMessage;
import server.messaging.PutRequestMessage;
import server.messaging.RequestMessage;
import server.messaging.ResultMessage;
import server.messaging.queue.ResultMessageQueue;
import server.messaging.queue.ResultMessageQueueManager;
import server.persist.PersistDataMessageQueue;
import server.persist.PersistDataMessageQueueManager;


public class DataMessagePoolImpl implements DataMessagePool {

	private PersistDataMessageQueueManager dataMessageQueueManager;
	private ResultMessageQueueManager resultMessageQueueManager;
	private RequestProcessor requestProcessor;
	
	public DataMessagePoolImpl() throws RemoteException {
		dataMessageQueueManager = PersistDataMessageQueueManager.instance();	
		resultMessageQueueManager = ResultMessageQueueManager.instance();
		requestProcessor = new RequestProcessor();
		UnicastRemoteObject.exportObject(this); 
	}
	
	
	
	
	

	// receive request from client, according to the request type, dispatch it to
	// the corresponding method which handles it
	public AckMessage receiveRequest(RequestMessage msg) throws RemoteException {
		// to be implemented
		
	}


	// retrieve the ResultMessage according to the queue and 
	public ResultMessage retrieveResult(AckMessage msg) throws RemoteException {
		// to be implemented
		
		
	}
	
	public class RequestProcessor {
				
		public RequestProcessor() {
			// to be implemented
		}
		
		
		
		//	process create queue request from clients
		private AckMessage processCreateQueueRequest(CreateQueueRequestMessage req) {
			// to be implemented
		}
		
		// process delete queue request
		private AckMessage processDeleteQueueRequest(DeleteQueueRequestMessage req) {
			// to be implemented
		}
		
		// process put message request
		private AckMessage processPutRequest(PutRequestMessage req) {
			// to be implemented
		}

		// process get message request
		private AckMessage processGetRequest(GetRequestMessage req) {
			// to be implemented
		}
	}
	
}	
	
	


