
package server.messaging.queue;

import java.util.Hashtable;

import server.messaging.ResultMessage;


public class ResultMessageQueueManager {
	protected static ResultMessageQueueManager queueManager;
	
	private Hashtable queueList;
	private ResultMessageQueue opQueue; // special queue which contains queue related operation result
	
	private ResultMessageQueueManager() {
		queueList = new Hashtable();
		// generate the Queue containing queue operations
		opQueue = new ResultMessageQueue("opQueue");
		
	}
	
	public static ResultMessageQueueManager instance() {
		if (queueManager == null) {
			queueManager = new ResultMessageQueueManager();
		}
		return queueManager;
	}
	
	public void insertResultMessage(ResultMessage msg, String qName) {
		
		ResultMessageQueue q = getQueue(qName);
		if (q == null) {
			createQueue(qName);
			q = getQueue(qName);
		}
		q.enqueue(msg);
			
		
		
	}
	
	public ResultMessageQueue getOpQueue() {
		return opQueue;
	}
	
	public ResultMessageQueue getQueue(String qName) {
		Object o = queueList.get(qName);
		ResultMessageQueue queue;
		if (o != null) {
			queue = (ResultMessageQueue) o;
			return queue;
		}
		else return null;
	}
	
	public ResultMessageQueue createQueue(String qName) {
		if (!queueList.containsKey(qName)) {
			ResultMessageQueue queue = new ResultMessageQueue(qName);
			queueList.put(qName, queue);
			return queue;
		}
		else {
			return (ResultMessageQueue) queueList.get(qName);
		}
	}

}
