package server.persist;

import java.io.Serializable;

public class PersistDataMessage implements Serializable{
	
	private static int size = 500;
	private static int nr = 0;
	
	private char[] content;
	
	
	private String queueName;
	private int messageNr;
	
	
	public PersistDataMessage(String msg, String qname) {
		char[] c = msg.toCharArray();
		int clength = c.length;
		
		// cut the rest if the msg is over-sized
		if (clength > size) {
			clength = size;
			content = new char[size];
			System.arraycopy(c, 0, content, 0, size);
		}
		else {
			content = new char[clength];
			System.arraycopy(c, 0, content, 0, clength);
		}
		
		queueName = qname;
		messageNr = ++nr;
		
	}
	
	public String getContent() {
		return String.copyValueOf(content);
	}
	
	public int getMessageNr() {
		return messageNr;
	}
	
	public String getQueueName() {
		return queueName;
	}
	
	
	
	
}
